from .. import elements as el
from .labeled_text_input import labeled_text_input


props_to_forward = (
    "value",
    "valid",
    "required",
    "placeholder",
    "background_color",
    "border",
)


def text_input(*label, **props):
    return labeled_text_input(el.text_input, props_to_forward, *label, **props)


def password(*label, **props):
    return labeled_text_input(el.password, props_to_forward, *label, **props)


def date(*label, **props):
    return labeled_text_input(
        el.date,
        [prop for prop in props_to_forward if prop != "placeholder"],
        *label,
        **props
    )


def search(*label, **props):
    return labeled_text_input(el.search, props_to_forward, *label, **props)
