from ..core.element import Prop
from .theme import theme_prop
from .label_element import LabelElement
from .style_utils import (
    highlight,
    parse_border,
    parse_color,
    parse_cursor,
    parse_font_size,
    parse_font_weight,
    parse_outline,
    parse_padding,
    parse_width,
)


class button(LabelElement):
    disabled = Prop(False)
    role = Prop()

    # Override StyledElement
    background_color = theme_prop("primary_color")
    hover_background_color = Prop(
        lambda b: highlight(b.background_color),
        parse=parse_color,
    )
    active_background_color = Prop(
        lambda b: highlight(b.hover_background_color),
        parse=parse_color,
    )
    border_radius = theme_prop("border_radius")
    border = Prop(
        lambda b: (None, None, (3, "solid", highlight(b.background_color))),
        parse=parse_border,
    )
    padding = Prop(8, parse=parse_padding)
    font_family = theme_prop("font_family")
    font_color = Prop("#fff", parse=parse_color)
    font_weight = Prop("bold", parse=parse_font_weight)
    font_size = Prop("medium", parse=parse_font_size)
    cursor = Prop("pointer", parse=parse_cursor)
    focus_outline = Prop("auto", parse=parse_outline)

    width = Prop("fit-content", parse=parse_width)
