from .theme import theme_prop
from ..core.element import Prop, RemoveProp, parse_option
from .container import container


class modal(container):
    opened = Prop(False)
    position = Prop(
        "center", parse=parse_option("left", "top", "right", "bottom", "center")
    )
    background_color = theme_prop("background_color")
    cover_color = theme_prop("modal_cover_color")
    # These props are hardcoded to the appropriate values for a modal
    # in Modal.svelte and cannot be set by a user.
    role = RemoveProp()
    aria = RemoveProp()
