from ..core.element import Context


def push_scope(scope):
    Context.current().scope_stack.push(str(scope))


def pop_scope():
    Context.current().scope_stack.pop()


class scope:
    def __init__(self, scope):
        self._scope = scope

    def __enter__(self):
        push_scope(self._scope)

    def __exit__(self, exc_type, exc_val, exc_tb):
        pop_scope()
