from ..core.element import Element


class slot(Element):
    is_container = True

    def __init__(self, key=None):
        super().__init__(key=key)
        self._collector = self._context.collector_stack.current()

    def __exit__(self, exc_type, exc_val, exc_tb):
        super().__exit__(exc_type, exc_val, exc_tb)
        index = self._collector_index
        if index < 0:
            raise Exception("Cannot re-enter slot.")
        self._collector[index : index + 1] = self.children

    @property
    def _collector_index(self):
        try:
            return self._collector.index(self)
        except ValueError:
            return -1

    @property
    def is_empty(self):
        return self._collector_index >= 0
