from ..core.element import Prop
from .input_element import InputElement
from .style_utils import (
    parse_border,
    parse_border_radius,
    parse_color,
    parse_cursor,
    parse_font_family,
    parse_font_size,
    parse_font_weight,
    parse_height,
    parse_non_negative_number,
    parse_outline,
    parse_padding,
    parse_width,
)


class StyledElement(InputElement):
    width = Prop(parse=parse_width)
    height = Prop(parse=parse_height)
    padding = Prop(0, parse=parse_padding)
    border = Prop(parse=parse_border)
    background_color = Prop(parse=parse_color)
    hover_background_color = Prop(parse=parse_color)
    active_background_color = Prop(parse=parse_color)
    border_radius = Prop(0, parse=parse_border_radius)
    cursor = Prop(parse=parse_cursor)
    font_color = Prop(parse=parse_color)
    font_size = Prop(parse=parse_font_size)
    font_family = Prop(parse=parse_font_family)
    font_weight = Prop(parse=parse_font_weight)
    grow = Prop(0, parse=parse_non_negative_number)
    shrink = Prop(1, parse=parse_non_negative_number)
    min_width = Prop(parse=parse_width)
    min_height = Prop(parse=parse_height)
    outline = Prop(parse=parse_outline)
