from nose.tools import assert_raises
from ..container import (
    parse_wrap,
    parse_aria,
)


def test_parse_wrap():
    assert parse_wrap(True) == parse_wrap("wrap") == "wrap"
    assert parse_wrap(False) == parse_wrap("nowrap") == "nowrap"
    assert_raises(ValueError, parse_wrap, "something")


def test_parse_aria():
    d = dict(a=1, b="2", c=True, d=5.6)
    assert parse_aria(d) == d
    assert parse_aria(None) is None
    assert_raises(ValueError, parse_aria, 1)
    assert_raises(ValueError, parse_aria, "Hello")
    assert_raises(ValueError, parse_aria, {1: "hello"})
    assert_raises(ValueError, parse_aria, {object(): "hello"})
    assert_raises(ValueError, parse_aria, {"x": dict()})
    assert_raises(ValueError, parse_aria, {"1x": "Hello"})
    assert_raises(ValueError, parse_aria, {"&": "Hello"})
