from ...core.unittests import simple_test
from ..scope import scope, push_scope, pop_scope


@simple_test
def test_scope(ctx):
    stack = list(ctx.scope_stack.stack)

    s = scope("Hello")
    with s:
        assert ctx.scope_stack.stack == stack + ["Hello"]

    assert ctx.scope_stack.stack == stack

    push_scope("Hi")
    assert ctx.scope_stack.stack == stack + ["Hi"]

    pop_scope()
    assert ctx.scope_stack.stack == stack
