from ...core.unittests import simple_test
from ..state import state


@simple_test
def test_state(ctx):
    s = state()
    assert s._props == dict()

    s = state(a=1, b=2)
    assert s.a == 1
    assert s.b == 2

    assert set(s._props.keys()) == set(["a", "b"])

    s.a = 20
    s.b = 100

    assert s.a == 20
    assert s.b == 100

    # Nothing got collected:
    assert ctx.collector_stack.current() == []
