from ...core.unittests import simple_test
from ..text import parse_hd_markdown, text
from ..icon import Icons, inline_icon_html


def test_parse_markdown():
    assert parse_hd_markdown("hello") == "<p>hello</p>"
    assert parse_hd_markdown("# hi") == "<h1>hi</h1>"


@simple_test
def test_text_label(ctx):
    txt = text("hello", "there")
    assert txt.label == "hello there"

    txt = text("hello", Icons.CheeseSolid, "there")
    assert txt.label == f"hello {inline_icon_html(Icons.CheeseSolid)} there"
